DAT

' multibyte mail box (16 bytes) for cog to cog communication
' 
' data structure (hub RAM)
'       data - long[4], 16 bytes, long aligned
'       data length - byte, will be negative to flag the end of production, else <= 16
'                     0 means producer can write (= semaphore)
'       end flag - used only once in a processing chain, flags the end to the controller
' participants parameters:
'       start of data field
' participant variables (cog)
'       buffer start address - constant
'       buffer length address - constant
' methods
'       write16 --> producer
'       read16 --> consumer

CON
  MBOX_LEN_B = 16
  MBOX_LEN_L = MBOX_LEN_B / 4
  
VAR
{{ set these variable in the topmost object
  long mbox[MBOX_LEN_L]
  byte mbox_len
  byte mbox_endflag
}}

PUB mbox16_init(p_mbox)
  byte[@p_mbox][MBOX_LEN_B] := 0
  

